using System;

interface IStorable
{
	void Read();
	void Write(object obj);
	int Status { get; set; }

}

// ο ̽ 
interface ICompressible
{
	void Compress();
	void Decompress();
}

// IStorable  Document 
public class Document : IStorable
{
	public Document(string s) 
	{
		Console.WriteLine(
		"Creating document with: {0}", s);

	}

	// IStorable.Read
	public void Read()
	{
		Console.WriteLine(
			"Implementing the Read Method for IStorable");        
	}

	// IStorable.Write
	public void Write(object o)
	{
		Console.WriteLine(
		"Implementing the Write Method for IStorable");  
	}

	// IStorable.Status
	public int Status
	{
		get
		{
			return status;
		}

		set
		{
			status = value;
		}
	}

	private int status = 0;
}

public class Tester
{

	static void Main()
	{
		Document doc = new Document("Test Document");

		//  쿡 ĳ Ѵ.
		if (doc is IStorable)
		{
			IStorable isDoc = (IStorable) doc;
			isDoc.Read();
		}

		//  ˻ ϰ ȴ.
		if (doc is ICompressible)
		{
			ICompressible icDoc = (ICompressible) doc;
			icDoc.Compress();
		}
	}
}

