using System;

interface IStorable
{
	void Read();
	void Write();
}

interface ITalk
{
	void Talk();
	void Read();
}

// IStorable ϵ Document ϰ Ѵ.

public class Document : IStorable, ITalk
{
	// Document 
	public Document(string s) 
	{
		Console.WriteLine("Creating document with: {0}", s);

	}

	// Read  .
	public virtual void Read()
	{
		Console.WriteLine("Implementing IStorable.Read");        
	}

	public void Write()
	{
		Console.WriteLine("Implementing IStorable.Write");        

	}

	void ITalk.Read()
	{
		Console.WriteLine("Implementing ITalk.Read");
	}

	public void Talk()
	{
		Console.WriteLine("Implementing ITalk.Talk");
 	}

}

public class Tester
{

	static void Main()
	{

		// Document ü Ѵ.
		Document theDoc = new Document("Test Document");
		IStorable isDoc = theDoc as IStorable;
		if (isDoc != null)
		{
			isDoc.Read();
		}

		ITalk itDoc = theDoc as ITalk;
		if (itDoc != null)
		{
			itDoc.Read();
		}

			theDoc.Read();
			theDoc.Talk();

	}

}

