namespace Programming_CSharp
{
	using System;
	using System.Threading;

	class Tester
	{
		static void Main()
		{
			// Tester Ŭ νϽ Ѵ.
			Tester t = new Tester();

			// ܺ Main Ѵ. 
			t.DoTest(); 
		}

		public void DoTest()
		{
			//  迭 Ѵ. 
			Thread[] myThreads = 
			{
				new Thread( new ThreadStart(Decrementer) ),
				new Thread( new ThreadStart(Incrementer) ),
				new Thread( new ThreadStart(Incrementer) )              
			};

			//  带 Ѵ.
			int ctr = 1;
			foreach (Thread myThread in myThreads)
			{
				myThread.IsBackground=true;
				myThread.Start();
				myThread.Name = "Thread" + ctr.ToString();
				ctr++;
				Console.WriteLine("Started thread {0}", myThread.Name);
				Thread.Sleep(50);
			}

			// 带 Ų 
			//  1 Ų. 
			myThreads[1].Interrupt();

			//  尡   ٸ. 
			foreach (Thread myThread in myThreads)
			{
				myThread.Join();
			}

			//  尡 Ǹ ޽ Ѵ. 
			Console.WriteLine("All my threads are done.");
		}

		// 1000 ϴ Լ
		public void Decrementer()
		{
			try
			{
				for (int i = 1000;i>=0;i--)
				{
					Console.WriteLine(
						"Thread {0}. Decrementer: {1}", 
						Thread.CurrentThread.Name,
						i);
					Thread.Sleep(1);
				}
			}
			catch (ThreadInterruptedException)
			{
			Console.WriteLine(
				"Thread {0} interrupted! Cleaning up...",
				Thread.CurrentThread.Name);
			}
			finally
			{
				Console.WriteLine(
					"Thread {0} Exiting. ",
					Thread.CurrentThread.Name);
			}
		}

		// 1000 ϴ Լ 
		public void Incrementer()
		{
			try
			{
				for (int i =0;i<1000;i++)
				{
					Console.WriteLine(
						"Thread {0}. Incrementer: {1}", 
						Thread.CurrentThread.Name,
						i);
					Thread.Sleep(1);
				}
			}
			catch (ThreadInterruptedException)
			{
				Console.WriteLine(
					"Thread {0} interrupted! Cleaning up...",
					Thread.CurrentThread.Name);
			}
			finally
			{
				Console.WriteLine(
					"Thread {0} Exiting. ",
					Thread.CurrentThread.Name);
			}
		}
	}
}

