using System;
using System.Net.Sockets;

public class Client
{
    
	static public void Main( string[] Args )
	{

		//  ϱ  TcpClient Ѵ.
		TcpClient socketForServer;

		try
		{
			socketForServer = 
				new TcpClient("localHost", 65000);
		}
		catch
		{
			Console.WriteLine(
				"Failed to connect to server at {0}:65000", 
					"localhost");
			return;
		}

		// NetworkStream ü StreamReader ü Ѵ. 
		NetworkStream networkStream = 
			socketForServer.GetStream();
		System.IO.StreamReader streamReader = 
			new System.IO.StreamReader(networkStream);
        
		try
		{
			string outputString;

			// ȣƮ ͸ а ȭ鿡 Ѵ.
			do
			{
				outputString = streamReader.ReadLine();

				if( outputString != null )
				{
					Console.WriteLine(outputString);
				}
			}
			while( outputString != null );
		}
		catch
		{
			Console.WriteLine(
				"Exception reading from Server");
		}

		//  Ʈ ݴ´. 
		networkStream.Close();
	}
}

